#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winsock2.h>

void erro(char*);

int main(int argc, char *argv[]) {
	int remote_socket, message_length;
	struct sockaddr_in remote_address;
	WSADATA wsa_data;
	struct hostent *hostPtr;
	char msg[255];

	if (argc != 4) {
		erro("Sintaxe: cliw <host> <port> <string>\n");
	}
	if (WSAStartup(MAKEWORD(2, 0), &wsa_data) != 0) {
		erro("WSAStartup() failed\n");
	}

	if ((hostPtr = gethostbyname(argv[1])) == 0) {
		erro("Nao consegui obter endereco");
	}

    remote_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (remote_socket == INVALID_SOCKET)
    {
        WSACleanup();
        erro("socket() failed\n");
    }
    memset(&remote_address, 0, sizeof(remote_address));
    remote_address.sin_family = AF_INET;
    remote_address.sin_addr.s_addr = ((struct in_addr *) (hostPtr->h_addr))->s_addr;
    remote_address.sin_port = htons((short) atoi(argv[2]));

    if (connect(remote_socket, (struct sockaddr *) &remote_address, sizeof(remote_address)) == SOCKET_ERROR) {
        WSACleanup();
        erro("connect() failed\n");
    }
	
	if (send(remote_socket, argv[3], 1+strlen(argv[3]), 0) == SOCKET_ERROR) {
		WSACleanup();
		closesocket(remote_socket);
		erro("send() failed\n");
	}
	message_length = recv(remote_socket, msg, sizeof(msg), 0);
	if (message_length == SOCKET_ERROR) {
		erro("recv() failed\n");
	}
	printf("sema\n");
	msg[message_length] = '\0';
	printf("%s\n", msg);

    WSACleanup();
    closesocket(remote_socket);
    return 0;
}

void erro(char *msg) {
	printf("Erro: %s\n", msg);
	exit(-1);
}
